"{ Package: 'cvut:stx/goodies/newcompiler' }"

LibraryDefinition subclass:#cvut_stx_goodies_newcompiler
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!


!cvut_stx_goodies_newcompiler class methodsFor:'description'!

preRequisites
    "list all required packages.
     This list can be maintained manually or (better) generated and
     updated by scanning the superclass hierarchies and looking for
     global variable accesses. (the browser has a menu function for that)
     Howevery, often too much is found, and you may want to explicitely
     exclude individual packages in the #excludedFromPrerequisites method."

    ^ #(
        #'stx:goodies/refactoryBrowser/parser'    "RBIdentifierToken - referenced by IRDecompiler>>newVar: "
        #'stx:goodies/sunit'    "TestCase - superclass of IRTransformTest "
        #'stx:libbasic'    "Link - superclass of IRLine "
        #'stx:libbasic2'    "OrderedDictionary - referenced by IRBytecodeGenerator>>initialize "
        #'stx:libcomp'    "PrimitiveNode - referenced by IRFunction>>initialize "
        #'stx:libcompat'    "Preferences - referenced by IRDecompiler>>removeClosureCreation: "
        #'stx:libtool'    "Tools::Inspector2Tab - referenced by IRFunction>>inspector2TabIRCode "
        #'stx:libwidg'    "ScrollableView - referenced by IRFunction>>inspector2TabIRCode "
    )
! !

!cvut_stx_goodies_newcompiler class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        IRBuilder
        IRBuilderTest
        IRBytecodeGenerator
        IRFunction
        IRInstruction
        IRInterpreter
        IRSequence
        IRStackCount
        IRTransformTest
        #'cvut_stx_goodies_newcompiler'
        IRAccess
        IRClosure
        IRConstant
        IRDup
        IRJump
        IRLine
        IRMethod
        IRPop
        IRPrinter
        IRReturn
        IRSend
        IRTranslator
        IRBlockReturnTop
        IRInstVarAccess
        IRJumpIf
        IRJumpOverBlock
        IRLiteralVariableAccess
        IRTempAccess
        IRInstVarRead
        IRInstVarStore
        IRLiteralVariableRead
        IRLiteralVariableStore
        IRTempRead
        IRTempStore
    )
!

extensionMethodNames
    "lists the extension methods which are to be included in the project.
     Entries are 2-element array literals, consisting of class-name and selector."

    ^ #(
        ByteCodeCompiler literalArray:
        Class binding
        Class bindingOf:
    )
! !

!cvut_stx_goodies_newcompiler class methodsFor:'description - project information'!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'CVUT FEI & Mathieu Suen'

    "Created: / 11-06-2008 / 16:50:46 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

description
    "Return a description string which will appear in vc.def / bc.def"

    ^ 'Smalltalk/X Bytecode generation library based on Squeak''s NewCompiler'

    "Created: / 11-06-2008 / 16:50:46 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright Jan Vrany & Mathieu Suen 2008'

    "Created: / 11-06-2008 / 16:50:46 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'NewCompiler'

    "Created: / 11-06-2008 / 16:50:46 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!cvut_stx_goodies_newcompiler class methodsFor:'description - svn'!

svnRevisionNr
    "Return a SVN revision number of myself.
     This number is updated after a commit"

    ^ "$SVN-Revision:"'27'"$"
! !

!cvut_stx_goodies_newcompiler class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/cvut/stx/goodies/newcompiler/cvut_stx_goodies_newcompiler.st,v 1.4 2009/10/08 12:00:46 fm Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/cvut/stx/goodies/newcompiler/cvut_stx_goodies_newcompiler.st,v 1.4 2009/10/08 12:00:46 fm Exp $'
!

version_SVN
    ^ '$Id$'
! !
